public class Band {
  static String DEFAULT = "*" ;
  public String value ;
  public Band l = null ;
  public Band r = null ;

  public Band () {
    this ( null, null, DEFAULT ) ;
  }

  public Band ( String s ) {
    this () ;
    Band p = this ;
    for ( int i = 0; i < s.length(); i++ ) {
      p.value = ""+s.charAt ( i ) ;
      p = p.right() ;
    }
  }

  public Band ( Band left, Band right, String value ) {
    l = left ;
    r = right ;
    this.value = value ;
  }

  public Band left () {
    if ( l == null ) l = new Band ( (Band)null, this, DEFAULT ) ;
    return l ;
  }

  public Band right () {
    if ( r == null ) r = new Band ( this, null, DEFAULT ) ;
    return r ;
  }

  public Band left_until_default () {
    Band p = this ;
    while ( ! p.value.equals ( DEFAULT ) ) p = p.left () ;
    return p ;
  }

  public Band right_until_default () {
    Band p = this ;
    while ( ! p.value.equals ( DEFAULT ) ) p = p.right () ;
    return p ;
  }

  public Band post_shift_left () {
    Band p = left_until_default () ;
    p.left().r = p.right() ;
    p.right().l = p.left() ;
    p = right_until_default () ;
    p = new Band ( p.left(), p, DEFAULT ) ;
    p.left().r = p ;
    p.right().l = p ;
    return p ;
  }

  public Band post_shift_right () {
    Band p = right_until_default () ;
    p.left().r = p.right() ;
    p.right().l = p.left() ;
    p = left_until_default () ;
    p = new Band ( p, p.right(), DEFAULT ) ;
    p.left().r = p ;
    p.right().l = p ;
    return p ;
  }

  public String output () {
    Band p = this ;
    String s = "" ;
    while ( ! p.value.equals ( DEFAULT ) ) {
      s += p.value ;
      p = p.right () ;
    }
    return s ;
  }

  public String print ( int left, int right ) {
    String s = value ;
    if ( left > 0 ) s = left().print( left -1, 0 ) + s ;
    if ( right > 0 ) s += right().print ( 0, right -1 ) ;
    return s ;
  }

}
