import java.io.* ;
import java.util.* ;

public class Main {

  public static void main ( String args[] ) throws Exception {
    try {
      BufferedReader in = new BufferedReader ( new InputStreamReader ( System.in ) ) ;
      BufferedReader code = null ;
      PrintStream output = System.out ;
      boolean turing = true ;
      int debug = 0 ;
      for ( int i = 0; i < args.length; i++ ) {
        if ( args[i].equals ( "-i" ) ) {
          i++ ;
          in = new BufferedReader ( new FileReader ( args[i] ) ) ;
        } else if ( args[i].equals ( "-I" ) ) {
          i++ ;
          in = new BufferedReader ( new StringReader ( args[i] ) ) ;
        } else if ( args[i].equals ( "-v" ) ) {
          debug = 1 ;
        } else if ( args[i].equals ( "-vv" ) ) {
          debug = 2 ;
        } else if ( args[i].equals ( "-c" ) ) {
          i++ ;
	  code = new BufferedReader ( new FileReader ( args[i] ) ) ;
        } else if ( args[i].equals ( "-p" ) ) {
	  turing = false ;
        } else if ( args[i].equals ( "-o" ) ) {
          i++ ;
	  output = new PrintStream ( new FileOutputStream ( args[i] ) ) ;
        } else {
          System.err.println ( "boeser Parameter: " + args[i] ) ;
          return ;
        }
      }
      String input = in.readLine () ;
      if ( turing ) output.println ( Turing.run ( TuringCommandParser.parse ( code ), input, debug ) ) ;
      else output.println ( Post.run ( PostCommandParser.parse ( code ), input, debug ) ) ;
    } catch ( Exception e ) {
      System.err.println ( "FEHLER: " + e.getMessage () ) ;
    }
  }

}
