import java.util.* ;

public class Post {
  static String space39 = "                                       " ;
  public static String run ( HashMap code, String input, int debug ) throws Exception {
    Band band = new Band ( input ) ;
    String zustand = "1" ;
    boolean run = true ;
    while ( run ) {
      if ( debug > 1 ) System.err.println ( band.print ( 40, 40 ) ) ;
      if ( debug > 1 ) System.err.println ( "<" + space39 + "^" + space39 + ">" ) ;
      PostCommand command = (PostCommand)code.get ( zustand ) ;
      if ( command == null ) throw new Exception ( "Unbekannter Zustand: " + zustand ) ;
      String value = band.value ;
      if ( debug > 0 ) System.err.println ( zustand + ": " + command.print () ) ;
      switch ( command.kind ) {
        case 'L' : band = band.left () ;
                   zustand = command.state1 ;
		   break ;
	case 'R' : band = band.right () ;
	           zustand = command.state1 ;
		   break ;
        case '?' : zustand = ( value.equals ( command.value ) ? command.state1 : command.state2 ) ;
	           break ;
	case '!' : run = false ;
	           break ;
        case '>' : band.value = command.value ;
	           zustand = command.state1 ;
	           break ;
	case 'M' : if ( command.value.equals ( "SLS" ) ) band = band.left_until_default () ;
                   if ( command.value.equals ( "SRS" ) ) band = band.right_until_default () ;
		   if ( command.value.equals ( "SL" ) ) band = band.post_shift_left () ;
		   if ( command.value.equals ( "SR" ) ) band = band.post_shift_right () ;
	           zustand = command.state1 ;
      }

    }
    if ( debug > 1 ) System.err.println ( band.print ( 40, 40 ) ) ;
    if ( debug > 1 ) System.err.println ( "<" + space39 + "^" + space39 + ">" ) ;
    return band.output () ;
  }
}
