import java.util.* ;

public class TuringCommand {

  HashMap data ;

  public TuringCommand ( String str ) {
    data = new HashMap () ;
    StringTokenizer st = new StringTokenizer ( str, "\n" ) ;
    while ( st.hasMoreTokens () ) {
      String s = st.nextToken () ;
      String index = s.substring ( 0, s.indexOf ( "->" ) ).trim() ;
      s = s.substring ( s.indexOf ( "->" ) + 2 ) ;
      TuringCommandPart p = new TuringCommandPart () ;
      p.write = s.substring ( 0, s.indexOf ( "," ) ).trim() ;
      s = s.substring ( s.indexOf ( "," ) + 1 ) ;
      p.move = s.substring ( 0, s.indexOf ( "," ) ).trim().charAt ( 0 ) ;
      p.state = s.substring ( s.indexOf ( "," ) + 1 ) ;
      data.put ( index, p ) ;
    }
  }

  public TuringCommandPart get ( String s ) throws Exception {
    TuringCommandPart ct = ((TuringCommandPart)data.get ( s )) ;
    if ( ct == null ) throw new Exception ( "Undefiniertes Symbol: " + s ) ;
    return ct ;
  }

  public String write ( String s ) throws Exception {
    return get ( s ).write ;
  }

  public char move ( String s ) throws Exception {
    return get ( s ).move ;
  }

  public String state ( String s ) throws Exception {
    return get ( s ).state ;
  }

  public String print ( String s ) throws Exception {
    return s + " -> " + write ( s ) + "," + move ( s ) + "," + state ( s ) ;
  }

}
